package cn.com.venvy.common.utils;

import android.text.TextUtils;

import java.io.File;
import java.io.FileInputStream;
import java.math.BigInteger;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;

public class VenvyMD5Util {

    public static String vvcommontokenencryption(String appKeyStr, String jsonStr, String bundleIDStr) {
        try {
            String mApp = jsonStr + appKeyStr + bundleIDStr;
            //开始加密
            String encryptionString = MD5(SHA(SHA(MD5(mApp), "SHA-256"), "SHA-256"));
            return encryptionString;
        } catch (Exception e) {
            e.printStackTrace();
        }
        return null;
    }

    public static String encodeByMD5(String originstr) {
        if (TextUtils.isEmpty(originstr))
            return null;
        return null;
    }

    public final static String MD5(String s) {
        char hexDigits[] = {'0', '1', '2', '3', '4',
                '5', '6', '7', '8', '9',
                'A', 'B', 'C', 'D', 'E', 'F'};
        try {
            byte[] btInput = s.getBytes("UTF-8");
            //获得MD5摘要算法的 MessageDigest 对象
            MessageDigest mdInst = MessageDigest.getInstance("MD5");
            //使用指定的字节更新摘要
            mdInst.update(btInput);
            //获得密文
            byte[] md = mdInst.digest();
            //把密文转换成十六进制的字符串形式
            int j = md.length;
            char str[] = new char[j * 2];
            int k = 0;
            for (int i = 0; i < j; i++) {
                byte byte0 = md[i];
                str[k++] = hexDigits[byte0 >>> 4 & 0xf];
                str[k++] = hexDigits[byte0 & 0xf];
            }
            return new String(str).toLowerCase();
        } catch (Exception e) {
            e.printStackTrace();
            return null;
        }
    }

    /**
     * 字符串 SHA 加密
     *
     * @return
     */
    private static String SHA(final String strText, final String strType) {
        // 返回值
        String strResult = null;

        // 是否是有效字符串
        if (strText != null && strText.length() > 0) {
            try {
                // SHA 加密开始
                // 创建加密对象 并傳入加密類型
                MessageDigest messageDigest = MessageDigest.getInstance(strType);
                // 传入要加密的字符串
                messageDigest.update(strText.getBytes());
                // 得到 byte 類型结果
                byte byteBuffer[] = messageDigest.digest();

                // 將 byte 轉換爲 string
                StringBuffer strHexString = new StringBuffer();
                // 遍歷 byte buffer
                for (int i = 0; i < byteBuffer.length; i++) {
                    String hex = Integer.toHexString(0xff & byteBuffer[i]);
                    if (hex.length() == 1) {
                        strHexString.append('0');
                    }
                    strHexString.append(hex);
                }
                // 得到返回結果
                strResult = strHexString.toString();
            } catch (NoSuchAlgorithmException e) {
                e.printStackTrace();
            }
        }

        return strResult;
    }

    public static String EncoderByMd5(File file) {
        if (!file.isFile()) {
            return null;
        }
        String encodeMd5String;
        try {
            MessageDigest digest = MessageDigest.getInstance("MD5");
            byte buffer[] = VenvyFileUtil.readBytes(file);
            if (buffer != null) {
                digest.update(buffer);
            }
            BigInteger bigInt = new BigInteger(1, digest.digest());
            encodeMd5String = bigInt.toString(16);
        } catch (Exception e) {
            e.printStackTrace();
            encodeMd5String = null;
        }
        return encodeMd5String;
    }
}
